<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../input-element/input-element.html">

<dom-module id="dependencia-componente">
  <template>
    <style>
      :host {
        display: block;
      }
    </style>
    <h2>Hello [[prop1]]!</h2>
    <hr>
    <input-element id="input_element"
      placeholder="escribe algo"
      on-input="inputHandler"
      on-custom-input="customInputHandler">
    </input-element>
    <hr>
    <p><strong>ValorEnInputElement: </strong>{{valorEnBaseInput}}</p>
  </template>

  <script>
    /**
     * `dependencia-componente`
     * 
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class DependenciaComponente extends Polymer.Element {
      static get is() { return 'dependencia-componente'; }
      static get properties() {
        return {
          prop1: {
            type: String,
            value: 'dependencia-componente'
          },
          valorEnBaseInput: {
            type: String
          }
        };
      }
      constructor(){
        super();
        this.addEventListener('custom-input', (e) => {
          console.log('custom-input en input-element con on-custom-input', e);
        });
      }
      customInputHandler(e) {
        console.log('on-custom-input en input-element con on-custom-input', e);
      }
      inputHandler(e) {
        console.log('input-element con on-input');
        this.valorEnBaseInput = this.$.input_element.currentValue;
      }
    }

    window.customElements.define(DependenciaComponente.is, DependenciaComponente);
  </script>
</dom-module>
